<p align="center">
<img src="https://github.com/AnalyticalGraphicsInc/cesium/wiki/logos/Cesium_Logo_Color.jpg" width="50%" />
</p>

Cesium is a JavaScript library for creating 3D globes and 2D maps in a web browser without a plugin. It uses WebGL for hardware-accelerated graphics, and is cross-platform, cross-browser, and tuned for dynamic-data visualization.

http://cesiumjs.org/

### Get Started ###

See the [Cesium Up and Running](http://cesiumjs.org/2013/04/12/Cesium-up-and-running/) tutorial.  Have questions?  Ask them on the [forum](https://groups.google.com/d/forum/cesium-dev).

Interested in contributing?  See the [wiki](https://github.com/AnalyticalGraphicsInc/cesium/wiki).

### Mission ###

Our mission is to create the leading web-based globe and map for visualizing dynamic data.  We strive for the best possible performance, precision, visual quality, ease of use, platform support, and content.

### License ###

[Apache 2.0](http://www.apache.org/licenses/LICENSE-2.0.html).  Cesium is free for both commercial and non-commercial use.

We appreciate attribution by including the Cesium logo and link in your app.

### Featured Demos ###

<p align="center">
<a href="http://cesiumjs.org/Cesium/Apps/Sandcastle/index.html"><img src="http://cesiumjs.org/images/Sandcastle.png" height="150" /></a>&nbsp;
<a href="http://apps.agi.com/SatelliteViewer/"><img src="http://cesiumjs.org/images/SatelliteViewer.png" height="150" /></a>&nbsp;
<a href="http://cesiumjs.org/demos/noradtrackssanta.html"><img src="http://cesiumjs.org/demos/images/noradtrackssanta.png" height="150" /></a>&nbsp;
</p>

### Demos ###

<p align="center">
<a href="http://cesiumjs.org/demos/GPlates.html"><img src="http://cesiumjs.org/demos/images/GPlates.jpg" height="150" /></a>&nbsp;
<a href="http://cesiumjs.org/demos/ign.html"><img src="http://cesiumjs.org/demos/images/ign.png" height="150" /></a>&nbsp;
<a href="http://cesiumjs.org/demos/atovisualizer.html"><img src="http://cesiumjs.org/demos/images/atovisualizer.jpg" height="150" /></a>&nbsp;
<a href="http://cesiumjs.org/demos/sunshine.html"><img src="http://cesiumjs.org/demos/images/sunshine.jpg" height="150" /></a>&nbsp;
<a href="http://cesiumjs.org/demos/doarama.html"><img src="http://cesiumjs.org/demos/images/doarama.jpg" height="150" /></a>&nbsp;
<a href="http://cesiumjs.org/demos/powdertracks.html"><img src="http://cesiumjs.org/demos/images/powdertracks.png" height="150" /></a>&nbsp;
<a href="http://cesiumjs.org/demos/earthkamexplorer.html"><img src="http://cesiumjs.org/demos/images/earthkamexplorer.png" height="150" /></a>&nbsp;
<a href="http://cesiumjs.org/demos/d3.html"><img src="http://cesiumjs.org/demos/images/d3.png" height="150" /></a>&nbsp;
<a href="http://cesiumjs.org/demos/koansys.html"><img src="http://cesiumjs.org/demos/images/koansys.png" height="150" /></a>&nbsp;
<a href="http://cesiumjs.org/demos/subspace.html"><img src="http://cesiumjs.org/demos/images/subspace.png" height="150" /></a>&nbsp;
<a href="http://cesiumjs.org/demos/agsattrack.html"><img src="http://cesiumjs.org/demos/images/agsattrack.png" height="150" /></a>&nbsp;
<a href="http://cesiumjs.org/demos/weblvcsimulationviewer.html"><img src="http://cesiumjs.org/demos/images/weblvcsimulationviewer.png" height="150" /></a>&nbsp;
<a href="http://cesiumjs.org/demos/vega.html"><img src="http://cesiumjs.org/demos/images/vega.png" height="150" /></a>&nbsp;
<a href="http://cesiumjs.org/Cesium/Build/Apps/CesiumViewer/"><img src="http://cesiumjs.org/images/CesiumViewer.png" height="150" /></a>&nbsp;
</p>

